"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var parseFilterKey = function (key, parser) {
    return function (filter) {
        if (lodash_1.has(filter, key)) {
            var otherKeys = lodash_1.difference(Object.keys(filter), [key]);
            var remainingFilter = lodash_1.pick(filter, otherKeys);
            return __assign({}, remainingFilter, parser(lodash_1.get(filter, key)));
        }
        else if (lodash_1.isArray(filter)) {
            return lodash_1.map(filter, parseFilterKey(key, parser));
        }
        else if (lodash_1.isPlainObject(filter)) {
            return lodash_1.mapValues(filter, parseFilterKey(key, parser));
        }
        return filter;
    };
};
exports.default = parseFilterKey;
//# sourceMappingURL=parseFilterKey.js.map